| http://www.sim.no/ http://www.coin3d.org/

Public Member Functions | Protected Member Functions | List of all members
SbSpherePlaneProjector Class Reference
Projector Classes

The SbSpherePlaneProjector class projects 2D points to a half-sphere and a plane.This projector uses a plane along with the half-sphere of SbSphereSectionProjector for projections. If the 2D point mapping "misses" the sphere section, the 3D point will be projected onto the plane. More...

`#include <Inventor/projectors/SbSpherePlaneProjector.h>`

Inheritance diagram for SbSpherePlaneProjector:

## Public Member Functions

| SbSpherePlaneProjector (const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
| SbSpherePlaneProjector (const SbSphere &sph, const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
virtual SbProjector * | copy (void) const
virtual SbVec3f | project (const SbVec2f &point)
virtual SbRotation | getRotation (const SbVec3f &point1, const SbVec3f &point2)
Public Member Functions inherited from SbSphereSectionProjector
| SbSphereSectionProjector (const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
| SbSphereSectionProjector (const SbSphere &sph, const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
void | setTolerance (const float edgetol)
float | getTolerance (void) const
void | setRadialFactor (const float rad=0.0f)
float | getRadialFactor (void) const
SbBool | isWithinTolerance (const SbVec3f &point)
Public Member Functions inherited from SbSphereProjector
SbVec3f | projectAndGetRotation (const SbVec2f &point, SbRotation &rot)
void | setSphere (const SbSphere &sph)
const SbSphere & | getSphere (void) const
void | setOrientToEye (const SbBool orienttoeye)
SbBool | isOrientToEye (void) const
void | setFront (const SbBool infront)
SbBool | isFront (void) const
SbBool | isPointInFront (const SbVec3f &point) const
virtual void | setWorkingSpace (const SbMatrix &space)
Public Member Functions inherited from SbProjector
virtual void | setViewVolume (const SbViewVolume &vol)
const SbViewVolume & | getViewVolume (void) const
const SbMatrix & | getWorkingSpace (void) const
virtual SbBool | tryProject (const SbVec2f &point, const float epsilon, SbVec3f &result)

## Protected Member Functions

SbRotation | getRotation (const SbVec3f &point1, const SbBool tol1, const SbVec3f &point2, const SbBool tol2)
Protected Member Functions inherited from SbSphereSectionProjector
virtual void | setupTolerance (void)
Protected Member Functions inherited from SbSphereProjector
| SbSphereProjector (const SbBool orienttoeye)
| SbSphereProjector (const SbSphere &s, const SbBool orienttoeye)
SbBool | intersectSphereFront (const SbLine &l, SbVec3f &result)
Protected Member Functions inherited from SbProjector
| SbProjector (void)
virtual | ~SbProjector ()
SbLine | getWorkingLine (const SbVec2f &point) const
float | findVanishingDistance (void) const
SbBool | verifyProjection (const SbVec3f &projpt) const

## Additional Inherited Members

Protected Attributes inherited from SbSphereSectionProjector
float | tolerance
float | tolDist
float | radialFactor
SbVec3f | planePoint
SbVec3f | planeDir
float | planeDist
SbPlane | tolPlane
Protected Attributes inherited from SbSphereProjector
SbBool | intersectFront
SbSphere | sphere
SbBool | orientToEye
SbBool | needSetup
SbVec3f | lastPoint
Protected Attributes inherited from SbProjector
SbViewVolume | viewVol
SbMatrix | worldToWorking
SbMatrix | workingToWorld

## Detailed Description

The SbSpherePlaneProjector class projects 2D points to a half-sphere and a plane.

This projector uses a plane along with the half-sphere of SbSphereSectionProjector for projections. If the 2D point mapping "misses" the sphere section, the 3D point will be projected onto the plane.

See also
  SbCylinderPlaneProjector

## Constructor & Destructor Documentation

## ◆ SbSpherePlaneProjector() [1/2]

SbSpherePlaneProjector::SbSpherePlaneProjector | ( | const float | edgetol = `0.9f`,
|  | const SbBool | orienttoeye = `TRUE`
| ) |  |

Default constructor. See SbSphereSectionProjector::SbSphereSectionProjector().

## ◆ SbSpherePlaneProjector() [2/2]

SbSpherePlaneProjector::SbSpherePlaneProjector | ( | const SbSphere & | sph,
|  | const float | edgetol = `0.9f`,
|  | const SbBool | orienttoeye = `TRUE`
| ) |  |

Constructor with explicit specification of projection sphere.

## Member Function Documentation

## ◆ copy()

SbProjector * SbSpherePlaneProjector::copy | ( | void |  | ) | const

virtual

Construct and return a copy of this projector. The caller is responsible for destructing the new instance.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable is using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Reimplemented from SbSphereSectionProjector.

## ◆ project()

SbVec3f SbSpherePlaneProjector::project | ( | const SbVec2f & | point | ) |

virtual

Project the 2D point from normalized viewport coordinates to a 3D point. The mapping will be done in accordance with the type of the projector.

Reimplemented from SbSphereSectionProjector.

## ◆ getRotation() [1/2]

SbRotation SbSpherePlaneProjector::getRotation | ( | const SbVec3f & | point1,
|  | const SbVec3f & | point2
| ) |  |

virtual

Returns rotation on the projection surface which re-orients point1 to point2.

Reimplemented from SbSphereSectionProjector.

## ◆ getRotation() [2/2]

SbRotation SbSpherePlaneProjector::getRotation | ( | const SbVec3f & | point1,
|  | const SbBool | tol1,
|  | const SbVec3f & | point2,
|  | const SbBool | tol2
| ) |  |

protected

Calculates rotation from point1 to point2, with tol1 and tol2 deciding whether or not to use the tolerance setting.

The documentation for this class was generated from the following files:

- SbSpherePlaneProjector.h
- SbSpherePlaneProjector.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.